--- linux-linaro-3.4-2012.05-1_original/fs/yaffs2/yaffs_guts.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/fs/yaffs2/yaffs_guts.c	2014-07-29 17:28:38.819972000 +0800
@@ -1568,14 +1520,16 @@
 {
 	struct yaffs_dev *dev = obj->my_dev;
 	int i;
-	if (dev->param.n_caches > 0) {
-		for (i = 0; i < dev->param.n_caches; i++) {
-			if (dev->cache[i].object == obj &&
-			    dev->cache[i].chunk_id == chunk_id) {
-				dev->cache_hits++;
 
-				return &dev->cache[i];
-			}
+	if (dev->param.n_caches < 1)
+		return NULL;
+
+	for (i = 0; i < dev->param.n_caches; i++) {
+		if (dev->cache[i].object == obj &&
+		    dev->cache[i].chunk_id == chunk_id) {
+			dev->cache_hits++;
+
+			return &dev->cache[i];
 		}
 	}
 	return NULL;
@@ -1585,24 +1539,24 @@
 static void yaffs_use_cache(struct yaffs_dev *dev, struct yaffs_cache *cache,
 			    int is_write)
 {
+	int i;
 
-	if (dev->param.n_caches > 0) {
-		if (dev->cache_last_use < 0 || dev->cache_last_use > 100000000) {
-			/* Reset the cache usages */
-			int i;
-			for (i = 1; i < dev->param.n_caches; i++)
-				dev->cache[i].last_use = 0;
-
-			dev->cache_last_use = 0;
-		}
-
-		dev->cache_last_use++;
+	if (dev->param.n_caches < 1)
+		return;
 
-		cache->last_use = dev->cache_last_use;
+	if (dev->cache_last_use < 0 ||
+		dev->cache_last_use > 100000000) {
+		/* Reset the cache usages */
+		for (i = 1; i < dev->param.n_caches; i++)
+			dev->cache[i].last_use = 0;
 
-		if (is_write)
-			cache->dirty = 1;
+		dev->cache_last_use = 0;
 	}
+	dev->cache_last_use++;
+	cache->last_use = dev->cache_last_use;
+
+	if (is_write)
+		cache->dirty = 1;
 }
 
 /* Invalidate a single cache page.
@@ -1611,9 +1565,10 @@
  */
 static void yaffs_invalidate_chunk_cache(struct yaffs_obj *object, int chunk_id)
 {
+	struct yaffs_cache *cache;
+
 	if (object->my_dev->param.n_caches > 0) {
-		struct yaffs_cache *cache =
-		    yaffs_find_chunk_cache(object, chunk_id);
+		cache = yaffs_find_chunk_cache(object, chunk_id);
 
 		if (cache)
 			cache->object = NULL;
@@ -1653,17 +1608,19 @@
 /*  FreeObject frees up a Object and puts it back on the free list */
 static void yaffs_free_obj(struct yaffs_obj *obj)
 {
-	struct yaffs_dev *dev = obj->my_dev;
+	struct yaffs_dev *dev;
 
+	if (!obj) {
+		BUG();
+		return;
+	}
+	dev = obj->my_dev;
 	yaffs_trace(YAFFS_TRACE_OS, "FreeObject %p inode %p",
 		obj, obj->my_inode);
-
-	if (!obj)
-		YBUG();
 	if (obj->parent)
-		YBUG();
+		BUG();
 	if (!list_empty(&obj->siblings))
-		YBUG();
+		BUG();
 
 	if (obj->my_inode) {
 		/* We're still hooked up to a cached inode.
@@ -1688,15 +1645,13 @@
 
 static int yaffs_generic_obj_del(struct yaffs_obj *in)
 {
-
-	/* First off, invalidate the file's data in the cache, without flushing. */
+	/* Iinvalidate the file's data in the cache, without flushing. */
 	yaffs_invalidate_whole_cache(in);
 
-	if (in->my_dev->param.is_yaffs2 && (in->parent != in->my_dev->del_dir)) {
-		/* Move to the unlinked directory so we have a record that it was deleted. */
+	if (in->my_dev->param.is_yaffs2 && in->parent != in->my_dev->del_dir) {
+		/* Move to unlinked directory so we have a deletion record */
 		yaffs_change_obj_name(in, in->my_dev->del_dir, _Y("deleted"), 0,
 				      0);
-
 	}
 
 	yaffs_remove_obj_from_dir(in);
@@ -1710,25 +1665,26 @@
 
 static void yaffs_soft_del_file(struct yaffs_obj *obj)
 {
-	if (obj->deleted &&
-	    obj->variant_type == YAFFS_OBJECT_TYPE_FILE && !obj->soft_del) {
-		if (obj->n_data_chunks <= 0) {
-			/* Empty file with no duplicate object headers,
-			 * just delete it immediately */
-			yaffs_free_tnode(obj->my_dev,
-					 obj->variant.file_variant.top);
-			obj->variant.file_variant.top = NULL;
-			yaffs_trace(YAFFS_TRACE_TRACING,
-				"yaffs: Deleting empty file %d",
-				obj->obj_id);
-			yaffs_generic_obj_del(obj);
-		} else {
-			yaffs_soft_del_worker(obj,
-					      obj->variant.file_variant.top,
-					      obj->variant.
-					      file_variant.top_level, 0);
-			obj->soft_del = 1;
-		}
+	if (!obj->deleted ||
+	    obj->variant_type != YAFFS_OBJECT_TYPE_FILE ||
+	    obj->soft_del)
+		return;
+
+	if (obj->n_data_chunks <= 0) {
+		/* Empty file with no duplicate object headers,
+		 * just delete it immediately */
+		yaffs_free_tnode(obj->my_dev, obj->variant.file_variant.top);
+		obj->variant.file_variant.top = NULL;
+		yaffs_trace(YAFFS_TRACE_TRACING,
+			"yaffs: Deleting empty file %d",
+			obj->obj_id);
+		yaffs_generic_obj_del(obj);
+	} else {
+		yaffs_soft_del_worker(obj,
+				      obj->variant.file_variant.top,
+				      obj->variant.
+				      file_variant.top_level, 0);
+		obj->soft_del = 1;
 	}
 }
 
@@ -1754,44 +1710,40 @@
 	int i;
 	int has_data;
 
-	if (tn) {
-		has_data = 0;
+	if (!tn)
+		return tn;
 
-		if (level > 0) {
-			for (i = 0; i < YAFFS_NTNODES_INTERNAL; i++) {
-				if (tn->internal[i]) {
-					tn->internal[i] =
-					    yaffs_prune_worker(dev,
-							       tn->internal[i],
-							       level - 1,
-							       (i ==
-								0) ? del0 : 1);
-				}
+	has_data = 0;
 
-				if (tn->internal[i])
-					has_data++;
+	if (level > 0) {
+		for (i = 0; i < YAFFS_NTNODES_INTERNAL; i++) {
+			if (tn->internal[i]) {
+				tn->internal[i] =
+				    yaffs_prune_worker(dev,
+						tn->internal[i],
+						level - 1,
+						(i == 0) ? del0 : 1);
 			}
-		} else {
-			int tnode_size_u32 = dev->tnode_size / sizeof(u32);
-			u32 *map = (u32 *) tn;
 
-			for (i = 0; !has_data && i < tnode_size_u32; i++) {
-				if (map[i])
-					has_data++;
-			}
+			if (tn->internal[i])
+				has_data++;
 		}
+	} else {
+		int tnode_size_u32 = dev->tnode_size / sizeof(u32);
+		u32 *map = (u32 *) tn;
 
-		if (has_data == 0 && del0) {
-			/* Free and return NULL */
-
-			yaffs_free_tnode(dev, tn);
-			tn = NULL;
+		for (i = 0; !has_data && i < tnode_size_u32; i++) {
+			if (map[i])
+				has_data++;
 		}
-
 	}
 
+	if (has_data == 0 && del0) {
+		/* Free and return NULL */
+		yaffs_free_tnode(dev, tn);
+		tn = NULL;
+	}
 	return tn;
-
 }
 
 static int yaffs_prune_tree(struct yaffs_dev *dev,
@@ -1802,34 +1754,34 @@
 	int done = 0;
 	struct yaffs_tnode *tn;
 
-	if (file_struct->top_level > 0) {
-		file_struct->top =
-		    yaffs_prune_worker(dev, file_struct->top,
-				       file_struct->top_level, 0);
-
-		/* Now we have a tree with all the non-zero branches NULL but the height
-		 * is the same as it was.
-		 * Let's see if we can trim internal tnodes to shorten the tree.
-		 * We can do this if only the 0th element in the tnode is in use
-		 * (ie all the non-zero are NULL)
-		 */
+	if (file_struct->top_level < 1)
+		return YAFFS_OK;
 
-		while (file_struct->top_level && !done) {
-			tn = file_struct->top;
+	file_struct->top =
+	   yaffs_prune_worker(dev, file_struct->top, file_struct->top_level, 0);
 
-			has_data = 0;
-			for (i = 1; i < YAFFS_NTNODES_INTERNAL; i++) {
-				if (tn->internal[i])
-					has_data++;
-			}
+	/* Now we have a tree with all the non-zero branches NULL but
+	 * the height is the same as it was.
+	 * Let's see if we can trim internal tnodes to shorten the tree.
+	 * We can do this if only the 0th element in the tnode is in use
+	 * (ie all the non-zero are NULL)
+	 */
 
-			if (!has_data) {
-				file_struct->top = tn->internal[0];
-				file_struct->top_level--;
-				yaffs_free_tnode(dev, tn);
-			} else {
-				done = 1;
-			}
+	while (file_struct->top_level && !done) {
+		tn = file_struct->top;
+
+		has_data = 0;
+		for (i = 1; i < YAFFS_NTNODES_INTERNAL; i++) {
+			if (tn->internal[i])
+				has_data++;
+		}
+
+		if (!has_data) {
+			file_struct->top = tn->internal[0];
+			file_struct->top_level--;
+			yaffs_free_tnode(dev, tn);
+		} else {
+			done = 1;
 		}
 	}
 
@@ -1838,43 +1790,44 @@
 
 /*-------------------- End of File Structure functions.-------------------*/
 
-/* AllocateEmptyObject gets us a clean Object. Tries to make allocate more if we run out */
+/* alloc_empty_obj gets us a clean Object.*/
 static struct yaffs_obj *yaffs_alloc_empty_obj(struct yaffs_dev *dev)
 {
 	struct yaffs_obj *obj = yaffs_alloc_raw_obj(dev);
 
-	if (obj) {
-		dev->n_obj++;
+	if (!obj)
+		return obj;
 
-		/* Now sweeten it up... */
+	dev->n_obj++;
 
-		memset(obj, 0, sizeof(struct yaffs_obj));
-		obj->being_created = 1;
+	/* Now sweeten it up... */
 
-		obj->my_dev = dev;
-		obj->hdr_chunk = 0;
-		obj->variant_type = YAFFS_OBJECT_TYPE_UNKNOWN;
-		INIT_LIST_HEAD(&(obj->hard_links));
-		INIT_LIST_HEAD(&(obj->hash_link));
-		INIT_LIST_HEAD(&obj->siblings);
-
-		/* Now make the directory sane */
-		if (dev->root_dir) {
-			obj->parent = dev->root_dir;
-			list_add(&(obj->siblings),
-				 &dev->root_dir->variant.dir_variant.children);
-		}
-
-		/* Add it to the lost and found directory.
-		 * NB Can't put root or lost-n-found in lost-n-found so
-		 * check if lost-n-found exists first
-		 */
-		if (dev->lost_n_found)
-			yaffs_add_obj_to_dir(dev->lost_n_found, obj);
+	memset(obj, 0, sizeof(struct yaffs_obj));
+	obj->being_created = 1;
 
-		obj->being_created = 0;
+	obj->my_dev = dev;
+	obj->hdr_chunk = 0;
+	obj->variant_type = YAFFS_OBJECT_TYPE_UNKNOWN;
+	INIT_LIST_HEAD(&(obj->hard_links));
+	INIT_LIST_HEAD(&(obj->hash_link));
+	INIT_LIST_HEAD(&obj->siblings);
+
+	/* Now make the directory sane */
+	if (dev->root_dir) {
+		obj->parent = dev->root_dir;
+		list_add(&(obj->siblings),
+			 &dev->root_dir->variant.dir_variant.children);
 	}
 
+	/* Add it to the lost and found directory.
+	 * NB Can't put root or lost-n-found in lost-n-found so
+	 * check if lost-n-found exists first
+	 */
+	if (dev->lost_n_found)
+		yaffs_add_obj_to_dir(dev->lost_n_found, obj);
+
+	obj->being_created = 0;
+
 	dev->checkpoint_blocks_required = 0;	/* force recalculation */
 
 	return obj;
@@ -1897,7 +1850,6 @@
 			lowest = dev->obj_bucket[dev->bucket_finder].count;
 			l = dev->bucket_finder;
 		}
-
 	}
 
 	return l;
@@ -1906,17 +1858,13 @@
 static int yaffs_new_obj_id(struct yaffs_dev *dev)
 {
 	int bucket = yaffs_find_nice_bucket(dev);
-
-	/* Now find an object value that has not already been taken
-	 * by scanning the list.
-	 */
-
 	int found = 0;
 	struct list_head *i;
-
 	u32 n = (u32) bucket;
 
-	/* yaffs_check_obj_hash_sane();  */
+	/* Now find an object value that has not already been taken
+	 * by scanning the list.
+	 */
 
 	while (!found) {
 		found = 1;
@@ -1931,7 +1879,6 @@
 			}
 		}
 	}
-
 	return n;
 }
 
@@ -1952,23 +1899,19 @@
 
 	list_for_each(i, &dev->obj_bucket[bucket].list) {
 		/* Look if it is in the list */
-		if (i) {
-			in = list_entry(i, struct yaffs_obj, hash_link);
-			if (in->obj_id == number) {
-
-				/* Don't tell the VFS about this one if it is defered free */
-				if (in->defered_free)
-					return NULL;
-
-				return in;
-			}
+		in = list_entry(i, struct yaffs_obj, hash_link);
+		if (in->obj_id == number) {
+			/* Don't show if it is defered free */
+			if (in->defered_free)
+				return NULL;
+			return in;
 		}
 	}
 
 	return NULL;
 }
 
-struct yaffs_obj *yaffs_new_obj(struct yaffs_dev *dev, int number,
+static struct yaffs_obj *yaffs_new_obj(struct yaffs_dev *dev, int number,
 				enum yaffs_obj_type type)
 {
 	struct yaffs_obj *the_obj = NULL;
@@ -1990,38 +1933,36 @@
 		return NULL;
 	}
 
-	if (the_obj) {
-		the_obj->fake = 0;
-		the_obj->rename_allowed = 1;
-		the_obj->unlink_allowed = 1;
-		the_obj->obj_id = number;
-		yaffs_hash_obj(the_obj);
-		the_obj->variant_type = type;
-		yaffs_load_current_time(the_obj, 1, 1);
+	the_obj->fake = 0;
+	the_obj->rename_allowed = 1;
+	the_obj->unlink_allowed = 1;
+	the_obj->obj_id = number;
+	yaffs_hash_obj(the_obj);
+	the_obj->variant_type = type;
+	yaffs_load_current_time(the_obj, 1, 1);
 
-		switch (type) {
-		case YAFFS_OBJECT_TYPE_FILE:
-			the_obj->variant.file_variant.file_size = 0;
-			the_obj->variant.file_variant.scanned_size = 0;
-			the_obj->variant.file_variant.shrink_size = ~0;	/* max */
-			the_obj->variant.file_variant.top_level = 0;
-			the_obj->variant.file_variant.top = tn;
-			break;
-		case YAFFS_OBJECT_TYPE_DIRECTORY:
-			INIT_LIST_HEAD(&the_obj->variant.dir_variant.children);
-			INIT_LIST_HEAD(&the_obj->variant.dir_variant.dirty);
-			break;
-		case YAFFS_OBJECT_TYPE_SYMLINK:
-		case YAFFS_OBJECT_TYPE_HARDLINK:
-		case YAFFS_OBJECT_TYPE_SPECIAL:
-			/* No action required */
-			break;
-		case YAFFS_OBJECT_TYPE_UNKNOWN:
-			/* todo this should not happen */
-			break;
-		}
+	switch (type) {
+	case YAFFS_OBJECT_TYPE_FILE:
+		the_obj->variant.file_variant.file_size = 0;
+		the_obj->variant.file_variant.scanned_size = 0;
+		the_obj->variant.file_variant.shrink_size =
+						yaffs_max_file_size(dev);
+		the_obj->variant.file_variant.top_level = 0;
+		the_obj->variant.file_variant.top = tn;
+		break;
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+		INIT_LIST_HEAD(&the_obj->variant.dir_variant.children);
+		INIT_LIST_HEAD(&the_obj->variant.dir_variant.dirty);
+		break;
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+		/* No action required */
+		break;
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+		/* todo this should not happen */
+		break;
 	}
-
 	return the_obj;
 }
 
@@ -2031,17 +1972,18 @@
 
 	struct yaffs_obj *obj =
 	    yaffs_new_obj(dev, number, YAFFS_OBJECT_TYPE_DIRECTORY);
-	if (obj) {
-		obj->fake = 1;	/* it is fake so it might have no NAND presence... */
-		obj->rename_allowed = 0;	/* ... and we're not allowed to rename it... */
-		obj->unlink_allowed = 0;	/* ... or unlink it */
-		obj->deleted = 0;
-		obj->unlinked = 0;
-		obj->yst_mode = mode;
-		obj->my_dev = dev;
-		obj->hdr_chunk = 0;	/* Not a valid chunk. */
-	}
 
+	if (!obj)
+		return NULL;
+
+	obj->fake = 1;	/* it is fake so it might not use NAND */
+	obj->rename_allowed = 0;
+	obj->unlink_allowed = 0;
+	obj->deleted = 0;
+	obj->unlinked = 0;
+	obj->yst_mode = mode;
+	obj->my_dev = dev;
+	obj->hdr_chunk = 0;	/* Not a valid chunk. */
 	return obj;
 
 }
@@ -2053,7 +1995,6 @@
 
 	dev->n_obj = 0;
 	dev->n_tnodes = 0;
-
 	yaffs_init_raw_tnodes_and_objs(dev);
 
 	for (i = 0; i < YAFFS_NOBJECT_BUCKETS; i++) {
@@ -2078,7 +2019,7 @@
 
 }
 
-YCHAR *yaffs_clone_str(const YCHAR * str)
+YCHAR *yaffs_clone_str(const YCHAR *str)
 {
 	YCHAR *new_str = NULL;
 	int len;
@@ -2114,6 +2055,7 @@
 static void yaffs_update_parent(struct yaffs_obj *obj)
 {
 	struct yaffs_dev *dev;
+
 	if (!obj)
 		return;
 	dev = obj->my_dev;
@@ -2131,7 +2073,7 @@
 
 	} else {
 		yaffs_update_oh(obj, NULL, 0, 0, 0, NULL);
-        }
+	}
 }
 
 void yaffs_update_dirty_dirs(struct yaffs_dev *dev)
@@ -2168,19 +2110,19 @@
 
 static struct yaffs_obj *yaffs_create_obj(enum yaffs_obj_type type,
 					  struct yaffs_obj *parent,
-					  const YCHAR * name,
+					  const YCHAR *name,
 					  u32 mode,
 					  u32 uid,
 					  u32 gid,
 					  struct yaffs_obj *equiv_obj,
-					  const YCHAR * alias_str, u32 rdev)
+					  const YCHAR *alias_str, u32 rdev)
 {
 	struct yaffs_obj *in;
 	YCHAR *str = NULL;
-
 	struct yaffs_dev *dev = parent->my_dev;
 
-	/* Check if the entry exists. If it does then fail the call since we don't want a dup. */
+	/* Check if the entry exists.
+	 * If it does then fail the call since we don't want a dup. */
 	if (yaffs_find_by_name(parent, name))
 		return NULL;
 
@@ -2193,68 +2135,65 @@
 	in = yaffs_new_obj(dev, -1, type);
 
 	if (!in) {
-		if (str)
-			kfree(str);
+		kfree(str);
 		return NULL;
 	}
 
-	if (in) {
-		in->hdr_chunk = 0;
-		in->valid = 1;
-		in->variant_type = type;
+	in->hdr_chunk = 0;
+	in->valid = 1;
+	in->variant_type = type;
 
-		in->yst_mode = mode;
+	in->yst_mode = mode;
 
-		yaffs_attribs_init(in, gid, uid, rdev);
+	yaffs_attribs_init(in, gid, uid, rdev);
 
-		in->n_data_chunks = 0;
+	in->n_data_chunks = 0;
 
-		yaffs_set_obj_name(in, name);
-		in->dirty = 1;
+	yaffs_set_obj_name(in, name);
+	in->dirty = 1;
 
-		yaffs_add_obj_to_dir(parent, in);
+	yaffs_add_obj_to_dir(parent, in);
 
-		in->my_dev = parent->my_dev;
+	in->my_dev = parent->my_dev;
 
-		switch (type) {
-		case YAFFS_OBJECT_TYPE_SYMLINK:
-			in->variant.symlink_variant.alias = str;
-			break;
-		case YAFFS_OBJECT_TYPE_HARDLINK:
-			in->variant.hardlink_variant.equiv_obj = equiv_obj;
-			in->variant.hardlink_variant.equiv_id =
-			    equiv_obj->obj_id;
-			list_add(&in->hard_links, &equiv_obj->hard_links);
-			break;
-		case YAFFS_OBJECT_TYPE_FILE:
-		case YAFFS_OBJECT_TYPE_DIRECTORY:
-		case YAFFS_OBJECT_TYPE_SPECIAL:
-		case YAFFS_OBJECT_TYPE_UNKNOWN:
-			/* do nothing */
-			break;
-		}
+	switch (type) {
+	case YAFFS_OBJECT_TYPE_SYMLINK:
+		in->variant.symlink_variant.alias = str;
+		break;
+	case YAFFS_OBJECT_TYPE_HARDLINK:
+		in->variant.hardlink_variant.equiv_obj = equiv_obj;
+		in->variant.hardlink_variant.equiv_id = equiv_obj->obj_id;
+		list_add(&in->hard_links, &equiv_obj->hard_links);
+		break;
+	case YAFFS_OBJECT_TYPE_FILE:
+	case YAFFS_OBJECT_TYPE_DIRECTORY:
+	case YAFFS_OBJECT_TYPE_SPECIAL:
+	case YAFFS_OBJECT_TYPE_UNKNOWN:
+		/* do nothing */
+		break;
+	}
 
-		if (yaffs_update_oh(in, name, 0, 0, 0, NULL) < 0) {
-			/* Could not create the object header, fail the creation */
-			yaffs_del_obj(in);
-			in = NULL;
-		}
+	if (yaffs_update_oh(in, name, 0, 0, 0, NULL) < 0) {
+		/* Could not create the object header, fail */
+		yaffs_del_obj(in);
+		in = NULL;
+	}
 
+	if (in)
 		yaffs_update_parent(parent);
-	}
 
 	return in;
 }
 
 struct yaffs_obj *yaffs_create_file(struct yaffs_obj *parent,
-				    const YCHAR * name, u32 mode, u32 uid,
+				    const YCHAR *name, u32 mode, u32 uid,
 				    u32 gid)
 {
 	return yaffs_create_obj(YAFFS_OBJECT_TYPE_FILE, parent, name, mode,
 				uid, gid, NULL, NULL, 0);
 }
 
-struct yaffs_obj *yaffs_create_dir(struct yaffs_obj *parent, const YCHAR * name,
+struct yaffs_obj *yaffs_create_dir(struct yaffs_obj *parent, const YCHAR *name,
 				   u32 mode, u32 uid, u32 gid)
 {
 	return yaffs_create_obj(YAFFS_OBJECT_TYPE_DIRECTORY, parent, name,
@@ -2262,7 +2201,7 @@
 }
 
 struct yaffs_obj *yaffs_create_special(struct yaffs_obj *parent,
-				       const YCHAR * name, u32 mode, u32 uid,
+				       const YCHAR *name, u32 mode, u32 uid,
 				       u32 gid, u32 rdev)
 {
 	return yaffs_create_obj(YAFFS_OBJECT_TYPE_SPECIAL, parent, name, mode,
@@ -2270,8 +2209,8 @@
 }
 
 struct yaffs_obj *yaffs_create_symlink(struct yaffs_obj *parent,
-				       const YCHAR * name, u32 mode, u32 uid,
-				       u32 gid, const YCHAR * alias)
+				       const YCHAR *name, u32 mode, u32 uid,
+				       u32 gid, const YCHAR *alias)
 {
 	return yaffs_create_obj(YAFFS_OBJECT_TYPE_SYMLINK, parent, name, mode,
 				uid, gid, NULL, alias, 0);
@@ -2281,22 +2220,40 @@
 struct yaffs_obj *yaffs_link_obj(struct yaffs_obj *parent, const YCHAR * name,
 				 struct yaffs_obj *equiv_obj)
 {
-	/* Get the real object in case we were fed a hard link as an equivalent object */
+	/* Get the real object in case we were fed a hard link obj */
 	equiv_obj = yaffs_get_equivalent_obj(equiv_obj);
 
-	if (yaffs_create_obj
-	    (YAFFS_OBJECT_TYPE_HARDLINK, parent, name, 0, 0, 0,
-	     equiv_obj, NULL, 0)) {
+	if (yaffs_create_obj(YAFFS_OBJECT_TYPE_HARDLINK,
+			parent, name, 0, 0, 0,
+			equiv_obj, NULL, 0))
 		return equiv_obj;
-	} else {
-		return NULL;
-	}
+
+	return NULL;
 
 }
 
 
 
-/*------------------------- Block Management and Page Allocation ----------------*/
+/*---------------------- Block Management and Page Allocation -------------*/
+
+static void yaffs_deinit_blocks(struct yaffs_dev *dev)
+{
+	if (dev->block_info_alt && dev->block_info)
+		vfree(dev->block_info);
+	else
+		kfree(dev->block_info);
+
+	dev->block_info_alt = 0;
+
+	dev->block_info = NULL;
+
+	if (dev->chunk_bits_alt && dev->chunk_bits)
+		vfree(dev->chunk_bits);
+	else
+		kfree(dev->chunk_bits);
+	dev->chunk_bits_alt = 0;
+	dev->chunk_bits = NULL;
+}
 
 static int yaffs_init_blocks(struct yaffs_dev *dev)
 {
@@ -2304,7 +2261,6 @@
 
 	dev->block_info = NULL;
 	dev->chunk_bits = NULL;
-
 	dev->alloc_block = -1;	/* force it to get a new one */
 
 	/* If the first allocation strategy fails, thry the alternate one */
@@ -2316,56 +2272,41 @@
 		dev->block_info_alt = 1;
 	} else {
 		dev->block_info_alt = 0;
-        }
+	}
+
+	if (!dev->block_info)
+		goto alloc_error;
 
-	if (dev->block_info) {
-		/* Set up dynamic blockinfo stuff. Round up bytes. */
-		dev->chunk_bit_stride = (dev->param.chunks_per_block + 7) / 8;
+	/* Set up dynamic blockinfo stuff. Round up bytes. */
+	dev->chunk_bit_stride = (dev->param.chunks_per_block + 7) / 8;
+	dev->chunk_bits =
+		kmalloc(dev->chunk_bit_stride * n_blocks, GFP_NOFS);
+	if (!dev->chunk_bits) {
 		dev->chunk_bits =
-			kmalloc(dev->chunk_bit_stride * n_blocks, GFP_NOFS);
-		if (!dev->chunk_bits) {
-			dev->chunk_bits =
-			    vmalloc(dev->chunk_bit_stride * n_blocks);
-			dev->chunk_bits_alt = 1;
-		} else {
-			dev->chunk_bits_alt = 0;
-                }
+		    vmalloc(dev->chunk_bit_stride * n_blocks);
+		dev->chunk_bits_alt = 1;
+	} else {
+		dev->chunk_bits_alt = 0;
 	}
+	if (!dev->chunk_bits)
+		goto alloc_error;
 
-	if (dev->block_info && dev->chunk_bits) {
-		memset(dev->block_info, 0,
-		       n_blocks * sizeof(struct yaffs_block_info));
-		memset(dev->chunk_bits, 0, dev->chunk_bit_stride * n_blocks);
-		return YAFFS_OK;
-	}
 
+	memset(dev->block_info, 0, n_blocks * sizeof(struct yaffs_block_info));
+	memset(dev->chunk_bits, 0, dev->chunk_bit_stride * n_blocks);
+	return YAFFS_OK;
+
+alloc_error:
+	yaffs_deinit_blocks(dev);
 	return YAFFS_FAIL;
 }
 
-static void yaffs_deinit_blocks(struct yaffs_dev *dev)
-{
-	if (dev->block_info_alt && dev->block_info)
-		vfree(dev->block_info);
-	else if (dev->block_info)
-		kfree(dev->block_info);
-
-	dev->block_info_alt = 0;
-
-	dev->block_info = NULL;
-
-	if (dev->chunk_bits_alt && dev->chunk_bits)
-		vfree(dev->chunk_bits);
-	else if (dev->chunk_bits)
-		kfree(dev->chunk_bits);
-	dev->chunk_bits_alt = 0;
-	dev->chunk_bits = NULL;
-}
 
 void yaffs_block_became_dirty(struct yaffs_dev *dev, int block_no)
 {
 	struct yaffs_block_info *bi = yaffs_get_block_info(dev, block_no);
-
 	int erased_ok = 0;
+	int i;
 
 	/* If the block is still healthy erase it and mark as clean.
 	 * If the block has had a data failure, then retire it.
@@ -2380,11 +2321,12 @@
 
 	bi->block_state = YAFFS_BLOCK_STATE_DIRTY;
 
-	/* If this is the block being garbage collected then stop gc'ing this block */
+	/* If this is the block being garbage collected then stop gc'ing */
 	if (block_no == dev->gc_block)
 		dev->gc_block = 0;
 
-	/* If this block is currently the best candidate for gc then drop as a candidate */
+	/* If this block is currently the best candidate for gc
+	 * then drop as a candidate */
 	if (block_no == dev->gc_dirtiest) {
 		dev->gc_dirtiest = 0;
 		dev->gc_pages_in_use = 0;
@@ -2400,13 +2342,13 @@
 		}
 	}
 
+	/* Verify erasure if needed */
 	if (erased_ok &&
-	    ((yaffs_trace_mask & YAFFS_TRACE_ERASE)
-	     || !yaffs_skip_verification(dev))) {
-		int i;
+	    ((yaffs_trace_mask & YAFFS_TRACE_ERASE) ||
+	     !yaffs_skip_verification(dev))) {
 		for (i = 0; i < dev->param.chunks_per_block; i++) {
-			if (!yaffs_check_chunk_erased
-			    (dev, block_no * dev->param.chunks_per_block + i)) {
+			if (!yaffs_check_chunk_erased(dev,
+				block_no * dev->param.chunks_per_block + i)) {
 				yaffs_trace(YAFFS_TRACE_ERROR,
 					">>Block %d erasure supposedly OK, but chunk %d not erased",
 					block_no, i);
@@ -2414,51 +2356,186 @@
 		}
 	}
 
-	if (erased_ok) {
-		/* Clean it up... */
-		bi->block_state = YAFFS_BLOCK_STATE_EMPTY;
-		bi->seq_number = 0;
-		dev->n_erased_blocks++;
-		bi->pages_in_use = 0;
-		bi->soft_del_pages = 0;
-		bi->has_shrink_hdr = 0;
-		bi->skip_erased_check = 1;	/* Clean, so no need to check */
-		bi->gc_prioritise = 0;
-		yaffs_clear_chunk_bits(dev, block_no);
-
-		yaffs_trace(YAFFS_TRACE_ERASE,
-			"Erased block %d", block_no);
-	} else {
+	if (!erased_ok) {
 		/* We lost a block of free space */
 		dev->n_free_chunks -= dev->param.chunks_per_block;
 		yaffs_retire_block(dev, block_no);
 		yaffs_trace(YAFFS_TRACE_ERROR | YAFFS_TRACE_BAD_BLOCKS,
 			"**>> Block %d retired", block_no);
+		return;
 	}
+
+	/* Clean it up... */
+	bi->block_state = YAFFS_BLOCK_STATE_EMPTY;
+	bi->seq_number = 0;
+	dev->n_erased_blocks++;
+	bi->pages_in_use = 0;
+	bi->soft_del_pages = 0;
+	bi->has_shrink_hdr = 0;
+	bi->skip_erased_check = 1;	/* Clean, so no need to check */
+	bi->gc_prioritise = 0;
+	bi->has_summary = 0;
+
+	yaffs_clear_chunk_bits(dev, block_no);
+
+	yaffs_trace(YAFFS_TRACE_ERASE, "Erased block %d", block_no);
 }
 
+static inline int yaffs_gc_process_chunk(struct yaffs_dev *dev,
+					struct yaffs_block_info *bi,
+					int old_chunk, u8 *buffer)
+{
+	int new_chunk;
+	int mark_flash = 1;
+	struct yaffs_ext_tags tags;
+	struct yaffs_obj *object;
+	int matching_chunk;
+	int ret_val = YAFFS_OK;
+
+	memset(&tags, 0, sizeof(tags));
+	yaffs_rd_chunk_tags_nand(dev, old_chunk,
+				 buffer, &tags);
+	object = yaffs_find_by_number(dev, tags.obj_id);
+
+	yaffs_trace(YAFFS_TRACE_GC_DETAIL,
+		"Collecting chunk in block %d, %d %d %d ",
+		dev->gc_chunk, tags.obj_id,
+		tags.chunk_id, tags.n_bytes);
+
+	if (object && !yaffs_skip_verification(dev)) {
+		if (tags.chunk_id == 0)
+			matching_chunk =
+			    object->hdr_chunk;
+		else if (object->soft_del)
+			/* Defeat the test */
+			matching_chunk = old_chunk;
+		else
+			matching_chunk =
+			    yaffs_find_chunk_in_file
+			    (object, tags.chunk_id,
+			     NULL);
+
+		if (old_chunk != matching_chunk)
+			yaffs_trace(YAFFS_TRACE_ERROR,
+				"gc: page in gc mismatch: %d %d %d %d",
+				old_chunk,
+				matching_chunk,
+				tags.obj_id,
+				tags.chunk_id);
+	}
+
+	if (!object) {
+		yaffs_trace(YAFFS_TRACE_ERROR,
+			"page %d in gc has no object: %d %d %d ",
+			old_chunk,
+			tags.obj_id, tags.chunk_id,
+			tags.n_bytes);
+	}
+
+	if (object &&
+	    object->deleted &&
+	    object->soft_del && tags.chunk_id != 0) {
+		/* Data chunk in a soft deleted file,
+		 * throw it away.
+		 * It's a soft deleted data chunk,
+		 * No need to copy this, just forget
+		 * about it and fix up the object.
+		 */
+
+		/* Free chunks already includes
+		 * softdeleted chunks, how ever this
+		 * chunk is going to soon be really
+		 * deleted which will increment free
+		 * chunks. We have to decrement free
+		 * chunks so this works out properly.
+		 */
+		dev->n_free_chunks--;
+		bi->soft_del_pages--;
+
+		object->n_data_chunks--;
+		if (object->n_data_chunks <= 0) {
+			/* remeber to clean up obj */
+			dev->gc_cleanup_list[dev->n_clean_ups] = tags.obj_id;
+			dev->n_clean_ups++;
+		}
+		mark_flash = 0;
+	} else if (object) {
+		/* It's either a data chunk in a live
+		 * file or an ObjectHeader, so we're
+		 * interested in it.
+		 * NB Need to keep the ObjectHeaders of
+		 * deleted files until the whole file
+		 * has been deleted off
+		 */
+		tags.serial_number++;
+		dev->n_gc_copies++;
+
+		if (tags.chunk_id == 0) {
+			/* It is an object Id,
+			 * We need to nuke the
+			 * shrinkheader flags since its
+			 * work is done.
+			 * Also need to clean up
+			 * shadowing.
+			 */
+			struct yaffs_obj_hdr *oh;
+			oh = (struct yaffs_obj_hdr *) buffer;
 
+			oh->is_shrink = 0;
+			tags.extra_is_shrink = 0;
+			oh->shadows_obj = 0;
+			oh->inband_shadowed_obj_id = 0;
+			tags.extra_shadows = 0;
+
+			/* Update file size */
+			if (object->variant_type == YAFFS_OBJECT_TYPE_FILE) {
+				yaffs_oh_size_load(oh,
+				    object->variant.file_variant.file_size);
+				tags.extra_file_size =
+				    object->variant.file_variant.file_size;
+			}
+
+			yaffs_verify_oh(object, oh, &tags, 1);
+			new_chunk =
+			    yaffs_write_new_chunk(dev, (u8 *) oh, &tags, 1);
+		} else {
+			new_chunk =
+			    yaffs_write_new_chunk(dev, buffer, &tags, 1);
+		}
+
+		if (new_chunk < 0) {
+			ret_val = YAFFS_FAIL;
+		} else {
+
+			/* Now fix up the Tnodes etc. */
+
+			if (tags.chunk_id == 0) {
+				/* It's a header */
+				object->hdr_chunk = new_chunk;
+				object->serial = tags.serial_number;
+			} else {
+				/* It's a data chunk */
+				yaffs_put_chunk_in_file(object, tags.chunk_id,
+							new_chunk, 0);
+			}
+		}
+	}
+	if (ret_val == YAFFS_OK)
+		yaffs_chunk_del(dev, old_chunk, mark_flash, __LINE__);
+	return ret_val;
+}
 
 static int yaffs_gc_block(struct yaffs_dev *dev, int block, int whole_block)
 {
 	int old_chunk;
-	int new_chunk;
-	int mark_flash;
 	int ret_val = YAFFS_OK;
 	int i;
 	int is_checkpt_block;
-	int matching_chunk;
 	int max_copies;
-
 	int chunks_before = yaffs_get_erased_chunks(dev);
 	int chunks_after;
-
-	struct yaffs_ext_tags tags;
-
 	struct yaffs_block_info *bi = yaffs_get_block_info(dev, block);
 
-	struct yaffs_obj *object;
-
 	is_checkpt_block = (bi->block_state == YAFFS_BLOCK_STATE_CHECKPOINT);
 
 	yaffs_trace(YAFFS_TRACE_TRACING,
